/**************************
	AJAX Library
	By Neo101
	Version 1.0.0
**************************/

var AjaxLib = {

	connectionArray : new Array(),
	numberOfConnections : 0,

	callDaemon: function(number, functionToCall){
		return function(){ functionToCall(number) }
	},
	
	openConnection : function(url, method, callBack, postData, isXMLDOM){
		if(isXMLDOM){
			var object = this.getActiveXObject("Microsoft.XMLDOM")
			if(object == null){
				alert('error getting ActiveX object')
				return null
			}
			object.onreadystatechange = this.callDaemon(this.numberOfConnections, AjaxLib.onreadystatechangeXMLDOM)
			object.async = true
		} else {
			var object = this.getActiveXObject("Microsoft.XMLHTTP")
			if(object == null){
				alert('error getting ActiveX object')
				return null
			}
			object.open(method, url, true)
			object.onreadystatechange = this.callDaemon(this.numberOfConnections, AjaxLib.onreadystatechangeXMLHTTP)
		}
		
		this.connectionArray[this.numberOfConnections] = {'object' : object, 'data': postData, 'callBack': callBack, 'isXMLDOM':isXMLDOM, 'url':url}
		this.numberOfConnections += 1
		
		return this.numberOfConnections - 1;
	},
	
	setHeader: function( number , headerName, headerData){
		this.connectionArray[number].object.setRequestHeader(headerName, headerData)
	},
	
	onreadystatechangeXMLHTTP: function( number ){
		var connectionObject = AjaxLib.connectionArray[number]
		if(connectionObject.object.readyState != 4){
			return
		}
		if(connectionObject.object.status != 200 && connectionObject.object.status != 201){
			connectionObject.callBack.onFailure(connectionObject)
		} else {
			var response
			if(connectionObject.callBack.returnXML == true){
				response = connectionObject.object.responseXML
			} else {
				try{
					response = connectionObject.object.responseText
				}catch(e){
					response = ''
				}
			}
			connectionObject.callBack.onSuccess(response, connectionObject)
		}
		
	},
	
	onreadystatechangeXMLDOM: function( number ){
		var connectionObject = AjaxLib.connectionArray[number]
		
		if(connectionObject.object.readyState != 4){
			return
		}
		//if(ajaxLib.connectionArray[number].object.status != 200 && ajaxLib.connectionArray[number].object.status != 201){
		//	ajaxLib.connectionArray[number].callBack.onFailure(ajaxLib.connectionArray[number])
		//} else {
			connectionObject.callBack.onSuccess(connectionObject.object, 
				AjaxLib.connectionArray[number])
		//}
		
	},
	
	
	makeCall : function( number ){
		if(this.connectionArray[number].isXMLDOM){
			AjaxLib.connectionArray[number].object.load( this.connectionArray[number].url )
		} else {
			AjaxLib.connectionArray[number].object.send( AjaxLib.connectionArray[number].data )
		}
	},

	
	getActiveXObject : function(objectName){
		try{
			var activeXObj = external.max_activex(SECURITY_ID, objectName)
		}
		catch(err){
			try{
				var activeXObj = new ActiveXObject(objectName)
			}
			catch(err){
				MaxLib.showError('Could not load ActiveX object ' + objectName)
				return null
			}
		}
		return activeXObj
	},
	
	clear : function( number ){ // don't know if it's really useful or not, but this should delete the ActiveX object, to save memory
		AjaxLib.connectionArray[number].object = null
		AjaxLib.connectionArray[number] = null
	},
	
	xmlToObject : function( xml ){ //very limited converter for xml -> javascript object
		var object = new Object()
		var isEmpty = true
		if(xml.attributes.length){	// element with attributes
			for(var i=0; i<xml.attributes.length; i++){
				object["@"+xml.attributes[i].nodeName] = (xml.attributes[i].nodeValue||"").toString();
				isEmpty = false
			}
		}
		if(xml.firstChild){ // element has child nodes ..
			for(var n=xml.firstChild; n; n=n.nextSibling){
				isEmpty = false
				if(n.nodeName == '#text'){
					object = n.nodeValue
					break
				} else {
					object[n.nodeName] = AjaxLib.xmlToObject(n)
				}
			}
		}
		if(isEmpty){
			return ''
		}
		return object
	}
}